local wm = GetWindowManager()
local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")


 local BufferTable = {}
       function BufferReached(key, buffer)
           if key == nil then return end
            if BufferTable[key] == nil then BufferTable[key] = {} end
            BufferTable[key].buffer = buffer or 3
            BufferTable[key].now = GetFrameTimeSeconds()
          if BufferTable[key].last == nil then BufferTable[key].last = BufferTable[key].now end
            BufferTable[key].diff = BufferTable[key].now - BufferTable[key].last
          BufferTable[key].eval = BufferTable[key].diff >= BufferTable[key].buffer
           if BufferTable[key].eval then BufferTable[key].last = BufferTable[key].now end
           return BufferTable[key].eval
       end



--    RR_ROUND = function(num, idp)
--     local mult = 10^(idp or 0)
--     return math.floor(num * mult + 0.5) / mult
--    end
			

local defaults =
{
	enableGuild = 1,
	enableGroup = 1,
	enableFriend = 1,
	enableAll = 1,
	enableLevel = 1,
	enableHealth = 1,
	enableHealthPercent = 1
    	
}

local function OnAddOnLoaded(eventCode, addOnName)
    if(addOnName == "RainbowReticle") then
	--SAVEDVARIABLES_DB used in the fire part of ZO_SavedVars:NewAccountWide
        savedVars = ZO_SavedVars:NewAccountWide("RAINBOWRETICLE_DB", 1, nil, defaults)
    end
end


-- If Reticle is hidden then hide icons
local function OnReticleHidden(eventcode)
	ZO_ReticleContainerReticle:SetColor(1,1,1)
	ZO_ReticleContainerStealthEye:SetColor(1,1,1)
	RainbowReticleUnitName:SetHidden(true)
end

-- If target has changed check it's a valid target then find out if they are friend of guildy
local function OnTargetHasChanged(eventcode,invname)

	isguild = false
	isguildno = 0
	isguildstring = ""
	ZO_ReticleContainerStealthEye:SetColor(1,1,1)
	ZO_ReticleContainerStealthText:SetColor(1,1,1)
	ZO_ReticleContainerReticle:SetColor(1,1,1)
	RainbowReticleUnitName:SetColor(1,1,1)
	RainbowReticleUnitHealth:SetColor(1,1,1)
	RainbowReticleUnitName:SetHidden(true)
	RainbowReticleUnitHealth:SetText("")
	RainbowReticleUnitHealth:SetHidden(true)
	-- Get the reticle target
	local target = GetUnitName('reticleover')
	
	-- Ignore blank targets
	local ignore = ( target == "")
	if CheckIsCritter( target ) and not ignore then
if savedVars.enableAll == 1 then
			RainbowReticleUnitName:SetText(GetUnitName('reticleover'))
			if savedVars.enableLevel == 1 then RainbowReticleUnitName:SetText(RainbowReticleUnitName:GetText() .. " (" .. GetUnitLevel('reticleover').. ")") end
			if savedVars.enableHealth == 1 or savedVars.enableHealthPercent == 1 then RainbowReticleUnitHealth:SetHidden(false) end

			RainbowReticleUnitName:SetHidden(false)

		end
	end
	if not CheckIsCritter( target ) and not ignore then

		for xguildid = 1, GetNumGuilds(), 1 do
			for xmemberid = 1, GetNumGuildMembers(xguildid), 1 do
				charvar = {GetGuildMemberCharacterInfo(xguildid, xmemberid)}
				if charvar[2] == GetRawUnitName('reticleover') then
					isguild = true
				end
			end
		end
		
	        -- Show Names for all other targets
		if savedVars.enableAll == 1 then
			RainbowReticleUnitName:SetText(GetUnitName('reticleover'))
			if savedVars.enableLevel == 1 then RainbowReticleUnitName:SetText(RainbowReticleUnitName:GetText() .. " (" .. GetUnitLevel('reticleover').. ")") end
			if savedVars.enableHealth == 1 or savedVars.enableHealthPercent == 1 then RainbowReticleUnitHealth:SetHidden(false) end
			RainbowReticleUnitName:SetHidden(false)

		end
		
		if isguild == true then
			ZO_ReticleContainerReticle:SetColor(.2,1,.2)
			ZO_ReticleContainerStealthEye:SetColor(.2,1,.2)
			ZO_ReticleContainerStealthText:SetColor(.2,1,.2)
			RainbowReticleUnitName:SetColor(.2,1,.2)
			RainbowReticleUnitHealth:SetColor(.2,1,.2)
			RainbowReticleUnitName:SetText(GetUnitName('reticleover'))
			if savedVars.enableLevel == 1 then RainbowReticleUnitName:SetText(RainbowReticleUnitName:GetText() .. " (" .. GetUnitLevel('reticleover').. ")") end
			if savedVars.enableGuild == 1 then
				if savedVars.enableHealth == 1 or savedVars.enableHealthPercent == 1 then RainbowReticleUnitHealth:SetHidden(false) end
				RainbowReticleUnitName:SetHidden(false)

			else
				RainbowReticleUnitName:SetHidden(true)

			end
			
		end
		if IsUnitFriend( 'reticleover' ) then
			RainbowReticleUnitName:SetText(GetUnitName('reticleover'))
			if savedVars.enableLevel == 1 then RainbowReticleUnitName:SetText(RainbowReticleUnitName:GetText() .. " (" .. GetUnitLevel('reticleover').. ")") end
			RainbowReticleUnitName:SetColor(.2,.2,1)
			RainbowReticleUnitHealth:SetColor(.2,.2,1)
			ZO_ReticleContainerReticle:SetColor(.2,.2,1)
			ZO_ReticleContainerStealthEye:SetColor(.2,.2,1)
			ZO_ReticleContainerStealthText:SetColor(.2,.2,1)
			if savedVars.enableFriend == 1 then
				if savedVars.enableHealth == 1 or savedVars.enableHealthPercent == 1 then RainbowReticleUnitHealth:SetHidden(false) end
				RainbowReticleUnitName:SetHidden(false)

			else
				RainbowReticleUnitName:SetHidden(true)

			end
		end
		if IsUnitGrouped('reticleover') then 
			RainbowReticleUnitName:SetText(GetUnitName('reticleover'))
			if savedVars.enableLevel == 1 then RainbowReticleUnitName:SetText(RainbowReticleUnitName:GetText() .. " (" .. GetUnitLevel('reticleover').. ")") end
			RainbowReticleUnitName:SetColor(.8235,.4117,.1176)
			RainbowReticleUnitHealth:SetColor(.8235,.4117,.1176)
			ZO_ReticleContainerReticle:SetColor(.8235,.4117,.1176)
			ZO_ReticleContainerStealthEye:SetColor(.8235,.4117,.1176)
			ZO_ReticleContainerStealthText:SetColor(.8235,.4117,.1176)
			if savedVars.enableGroup == 1 then
				if savedVars.enableHealth == 1 or savedVars.enableHealthPercent == 1 then RainbowReticleUnitHealth:SetHidden(false) end
				RainbowReticleUnitName:SetHidden(false)
			else
				RainbowReticleUnitName:SetHidden(true)
			end
		elseif GetUnitReaction('reticleover') == 3 or GetUnitReaction('reticleover') == 4 then
			--d(GetUnitReaction('reticleover'))
			RainbowReticleUnitName:SetColor(GetUnitReactionColor('reticleover') )
			RainbowReticleUnitHealth:SetColor(GetUnitReactionColor('reticleover') )
			ZO_ReticleContainerReticle:SetColor(GetUnitReactionColor('reticleover') )
			ZO_ReticleContainerStealthEye:SetColor(GetUnitReactionColor('reticleover'))
			ZO_ReticleContainerStealthText:SetColor(GetUnitReactionColor('reticleover'))

		end
		
		
		--local playercurrent,playermax,playereffmax = GetUnitPower('reticleover', POWERTYPE_HEALTH )
		--d(playercurrent..","..playermax..","..playereffmax)
		
	end
end

function ToggleEnableGuild()
	if savedVars.enableGuild == 0 then
		savedVars.enableGuild = 1
	else
		savedVars.enableGuild = 0
		RainbowReticleUnitName:SetHidden(true)
	end
end
function ToggleEnableFriend()
	if savedVars.enableFriend == 0 then
		savedVars.enableFriend = 1
	else
		savedVars.enableFriend = 0
		RainbowReticleUnitName:SetHidden(true)
	end
end
function ToggleEnableGroup()
	if savedVars.enableGroup == 0 then
		savedVars.enableGroup = 1
	else
		savedVars.enableGroup = 0
		RainbowReticleUnitName:SetHidden(true)
	end
end

function ToggleEnableAll()
	if savedVars.enableAll == 0 then
		savedVars.enableAll = 1
	else
		savedVars.enableAll = 0
		RainbowReticleUnitName:SetHidden(true)
	end
end

function ToggleEnableLevel()
	if savedVars.enableLevel == 0 then
		savedVars.enableLevel = 1
	else
		savedVars.enableLevel = 0

	end
end

function ToggleEnableHealth()
	if savedVars.enableHealth == 0 then
		savedVars.enableHealth = 1
	else
		savedVars.enableHealth = 0

	end
end

function ToggleEnableHealthPercent()
	if savedVars.enableHealthPercent == 0 then
		savedVars.enableHealthPercent = 1
	else
		savedVars.enableHealthPercent = 0

	end
end

-- Init RainbowReticle
function RainbowReticleInit()

	EVENT_MANAGER:RegisterForEvent("RainbowReticle", EVENT_ADD_ON_LOADED, OnAddOnLoaded)
	EVENT_MANAGER:RegisterForEvent("RainbowReticle", EVENT_RETICLE_TARGET_CHANGED, OnTargetHasChanged)
	EVENT_MANAGER:RegisterForEvent("RainbowReticles", EVENT_RETICLE_HIDDEN_UPDATE, OnReticleHidden)

	RainbowConfigCPid = LAM:CreateControlPanel( 'rainbowconfigpanel', '|cFF0000R|r|cFFFF00a|r|cFF33CCi|r|c00CC00n|r|c0033CCb|r|cCC3300o|r|c663300w|r Config' )
	LAM:AddHeader( RainbowConfigCPid, 'rainbowconfigheader', 'Rainbow Reticle Config' )
    LAM:AddDescription(RainbowConfigCPid, "rainbowdetailsnames", rainbownames, "NAMES")

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowguildnames', 'Enable Guild Names', 'If enabled player names of guild mates will be displayed',
        function() return savedVars.enableGuild end, function() ToggleEnableGuild() end )

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowfriendnames', 'Enable Friend Names', 'If enabled player names of friends will be displayed',
        function() return savedVars.enableFriend end, function() ToggleEnableFriend() end )

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowgroupnames', 'Enable Group Names', 'Will display player names of group members.',
        function() return savedVars.enableGroup end, function() ToggleEnableGroup() end )

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowall', 'Enable Other Names', 'Will display names for all other targets',
        function() return savedVars.enableAll end, function() ToggleEnableAll() end )

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowlevel', 'Enable Level Indicator', 'Will display level indicator for enabled targets',
        function() return savedVars.enableLevel end, function() ToggleEnableLevel() end )

    LAM:AddHeader(RainbowConfigCPid, "rainbowhps" , "")
    LAM:AddDescription(RainbowConfigCPid, "rainbowdetailshps", rainbowhphead, "HEALTH INDICATOR")

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowfriendhealth', 'Enable Health Values', 'If enabled targets health min/max numbers will be displayed',
        function() return savedVars.enableHealth end, function() ToggleEnableHealth() end )

LAM:AddCheckbox( RainbowConfigCPid, 'rainbowfriendhealthpercent', 'Enable Health Percentages', 'If enabled targets health percentages will be displayed',
        function() return savedVars.enableHealthPercent end, function() ToggleEnableHealthPercent() end )

    LAM:AddHeader(RainbowConfigCPid, "rainbowabout" , "")
    local rainbowdescription = "      Author: Mitazaki \n      Version: 0.9 \n      Copyright 2014 All Rights Reserved"
    LAM:AddDescription(RainbowConfigCPid, "rainbowdetails", rainbowdescription, "ABOUT RAINDOW RETICLE")
end

function RainbowReticleUpdate()
if not BufferReached("rainbowreticleupdatebuffer", .1) then return; end
	local target = GetUnitName('reticleover')
	
	-- Ignore blank targets
	local ignore = ( target == "")
	if not ignore then
 	       if savedVars.enableHealth == 1 or savedVars.enableHealthPercent == 1 then
			if IsUnitDead('reticleover') then
				RainbowReticleUnitHealth:SetText("DEAD")
			else
				local playercurrent,playermax,playereffmax = GetUnitPower('reticleover', POWERTYPE_HEALTH )
				local playerpercent = math.floor(playercurrent / playermax * 100)
				if savedVars.enableHealth == 1 then
					RainbowReticleUnitHealth:SetText(playercurrent.."/"..playermax)
				end 
				if savedVars.enableHealthPercent == 1 then
					if savedVars.enableHealth == 1 then RainbowReticleUnitHealth:SetText(RainbowReticleUnitHealth:GetText().." ("..playerpercent.."%)") else RainbowReticleUnitHealth:SetText(playerpercent.."%") end
				end 	
			end
		end
	end
end


-- Function to check if Critter
function CheckIsCritter( targetName )

	-- Critters are always level 1
	if ( GetUnitLevel('reticleover') ~= 1 ) then return false end

	-- The list of critters
	local critters = { 
		"Butterfly",
		"Lizard",
		"Rat",
		"Snake",
		"Pony Guar",
		"Frog",
		"Squirrel",
		"Rabbit",
		"Deer",
		"Cat",
		"Pig",
		"Sheep",
		"Antelope",
		"Wasp",
		"Monkey",
		"Fleshflies",
		"Centipede",
		"Chicken",
		"Torchbug",
		"Spider",
		"Scorpion",
		"Goat",
		"Scrib",
		"Scuttler",
	}
	
	-- Is the target a critter?
	for i = 1, #critters do
		if ( targetName == critters[i] ) then return true end
	end
	
	-- Otherwise false
	return false
end



